declare type Font = CSSStyleDeclaration | FontProperties | string;
interface FontProperties {
    fontFamily: string;
    fontSize: number;
    fontStretch?: string;
    fontStyle?: string;
    fontVariant?: string;
    fontWeight?: number | string;
    lineHeight?: number;
}

declare function getTextMetrics(text: string, font?: Font): Promise<TextMetrics>;
declare function getTextMetrics(text: string[], font?: Font): Promise<TextMetrics[]>;

export { Font, FontProperties, getTextMetrics };
